using System.Collections.Generic;
using UnityEngine;
using SimpleJSON;
using System.Collections.Generic;
using UnityEngine.Events;
using UnityEngine.UI;

/* 95% written by MeshedVR
Doc'0c adapted it to a plugin
*/
namespace ReVAMped
{

    public class WindControl : MVRScript
    {
        Atom windDirection;
        public static Vector3 globalWind = Vector3.zero;
        protected static Vector3  newDirection = Vector3.zero;
        protected string _missingReceiverStoreId = string.Empty;
        public bool isGlobal;
		public bool isAvatar;
        public bool isBlowing;
        protected float windRandomX;
        protected float windRandomY;
        protected float windRandomZ;
        protected JSONStorableBool isGlobalJSON;
		protected JSONStorableBool isAvatarJSON;
        protected JSONStorableBool isBlowingJSON;
        protected Atom receivingAtom;
        protected JSONStorableStringChooser atomJSON;
        protected JSONStorable receiver;
        protected JSONStorableStringChooser receiverJSON;
        protected string _receiverTargetName;
        protected JSONStorableVector3 receiverTarget;
        protected JSONStorableStringChooser receiverTargetJSON;
        protected JSONStorableFloat currentMagnitudeJSON;
        protected JSONStorableBool autoJSON;
        protected JSONStorableFloat periodJSON;
        protected JSONStorableFloat quicknessJSON;
        protected JSONStorableFloat windDecay;
        protected JSONStorableFloat avatarMobility;
        protected JSONStorableFloat windStrength;
        protected JSONStorableFloat windTurbulence;
        protected JSONStorableFloat targetMagnitudeJSON;
        protected JSONStorableFloat lowerMagnitudeJSON;
        protected JSONStorableFloat lowerMagnitudeRatioJSON;
        protected JSONStorableFloat upperMagnitudeJSON;
        protected float timer;
        protected Vector3 direction;
        protected Dictionary<string, ForceReceiver> receiverNameToForceReceiver;
        protected Rigidbody RB;
        protected UIDynamicButton btn;
        protected string _lastBrowseDir;

        protected JSONStorableFloat mobility_strong;
        protected JSONStorableFloat mobility_medium;
        protected JSONStorableFloat mobility_light;
        protected JSONStorableFloat mobility_controller;

        protected Dictionary<string, bool> RB_enabled;
        protected Dictionary<string, JSONStorableFloat> RB_mobility;

        protected void SyncReceiverRB(string receiver)
        {
            if (receiver != null)
            {
                ForceReceiver fr;
                if (receiverNameToForceReceiver.TryGetValue(receiver, out fr))
                {
                    RB = fr.GetComponent<Rigidbody>();
                }
                else
                {
                    RB = null;
                }
            }
            else
            {
                RB = null;
            }
        }

        protected void initRBdicts()
        {
            RB_enabled = new Dictionary<string, bool>();
            RB_mobility = new Dictionary<string, JSONStorableFloat>();

            mobility_light=new JSONStorableFloat("mobility_light", 1f, 0.1f, 1.0f, true, true);
            mobility_strong=new JSONStorableFloat("mobility_strong", 0.1f, 0.1f, 1.0f, true, true);
            mobility_medium=new JSONStorableFloat("mobility_medium", 0.5f, 0.1f, 1.0f, true, true);
            mobility_controller=new JSONStorableFloat("mobility_controller", 0.1f, 0.1f, 1.0f, true, true);
        }

        protected void SetDefaultRBmobility()
        {
            RB_mobility.Add("rNipple",mobility_light);
            RB_mobility.Add("lNipple",mobility_light);
            RB_mobility.Add("pelvis",mobility_strong);
            RB_mobility.Add("hip",mobility_strong);
            RB_mobility.Add("rThigh",mobility_light);
            RB_mobility.Add("lThigh",mobility_light);
            RB_mobility.Add("rShin",mobility_light);
            RB_mobility.Add("lShin",mobility_light);
            RB_mobility.Add("rFoot",mobility_controller);
            RB_mobility.Add("lFoot",mobility_controller);
            RB_mobility.Add("LGlute",mobility_medium);
            RB_mobility.Add("RGlute",mobility_medium);
            RB_mobility.Add("abdomen",mobility_light);
            RB_mobility.Add("abdomen2",mobility_light);
            RB_mobility.Add("chest",mobility_controller);
            RB_mobility.Add("rCollar",mobility_light);
            RB_mobility.Add("lCollar",mobility_light);
            RB_mobility.Add("rShldr",mobility_light);
            RB_mobility.Add("lShldr",mobility_light);
            RB_mobility.Add("rForeArm",mobility_light);
            RB_mobility.Add("lForeArm",mobility_light);
            RB_mobility.Add("rHand",mobility_controller);
            RB_mobility.Add("lHand",mobility_controller);
            RB_mobility.Add("rPectoral",mobility_medium);
            RB_mobility.Add("lPectoral",mobility_medium);
            RB_mobility.Add("neck",mobility_light);
            RB_mobility.Add("head",mobility_controller);
        }

        protected void SetDefaultRBenabled()
        {
            RB_enabled.Add("rNipple",false);
            RB_enabled.Add("lNipple",false);
            RB_enabled.Add("pelvis",false);
            RB_enabled.Add("hip",false);
            RB_enabled.Add("rThigh",false);
            RB_enabled.Add("lThigh",false);
            RB_enabled.Add("rShin",false);
            RB_enabled.Add("lShin",false);
            RB_enabled.Add("rFoot",false);
            RB_enabled.Add("lFoot",false);
            RB_enabled.Add("LGlute",false);
            RB_enabled.Add("RGlute",false);
            RB_enabled.Add("abdomen",false);
            RB_enabled.Add("abdomen2",false);
            RB_enabled.Add("chest",false);
            RB_enabled.Add("rCollar",false);
            RB_enabled.Add("lCollar",false);
            RB_enabled.Add("rShldr",false);
            RB_enabled.Add("lShldr",false);
            RB_enabled.Add("rForeArm",false);
            RB_enabled.Add("lForeArm",false);
            RB_enabled.Add("rHand",false);
            RB_enabled.Add("lHand",false);
            RB_enabled.Add("rPectoral",false);
            RB_enabled.Add("lPectoral",false);
            RB_enabled.Add("neck",false);
            RB_enabled.Add("head",false);
        }

        protected void RBpreset_disableAll()
        {
            this.GetBoolJSONParam("rNippleIsEnabled").val=false;
            this.GetBoolJSONParam("lNippleIsEnabled").val=false;
            this.GetBoolJSONParam("pelvisIsEnabled").val=false;
            this.GetBoolJSONParam("hipIsEnabled").val=false;
            this.GetBoolJSONParam("rThighIsEnabled").val=false;
            this.GetBoolJSONParam("lThighIsEnabled").val=false;
            this.GetBoolJSONParam("rShinIsEnabled").val=false;
            this.GetBoolJSONParam("lShinIsEnabled").val=false;
            this.GetBoolJSONParam("rFootIsEnabled").val=false;
            this.GetBoolJSONParam("lFootIsEnabled").val=false;
            this.GetBoolJSONParam("LGluteIsEnabled").val=false;
            this.GetBoolJSONParam("RGluteIsEnabled").val=false;
            this.GetBoolJSONParam("abdomenIsEnabled").val=false;
            this.GetBoolJSONParam("abdomen2IsEnabled").val=false;
            this.GetBoolJSONParam("chestIsEnabled").val=false;
            this.GetBoolJSONParam("rCollarIsEnabled").val=false;
            this.GetBoolJSONParam("lCollarIsEnabled").val=false;
            this.GetBoolJSONParam("rShldrIsEnabled").val=false;
            this.GetBoolJSONParam("lShldrIsEnabled").val=false;
            this.GetBoolJSONParam("rForeArmIsEnabled").val=false;
            this.GetBoolJSONParam("lForeArmIsEnabled").val=false;
            this.GetBoolJSONParam("rHandIsEnabled").val=false;
            this.GetBoolJSONParam("lHandIsEnabled").val=false;
            this.GetBoolJSONParam("rPectoralIsEnabled").val=false;
            this.GetBoolJSONParam("lPectoralIsEnabled").val=false;
            this.GetBoolJSONParam("neckIsEnabled").val=false;
            this.GetBoolJSONParam("headIsEnabled").val=false;
        }

        protected void RBpreset_enableAll()
        {
            this.GetBoolJSONParam("rNippleIsEnabled").val=true;
            this.GetBoolJSONParam("lNippleIsEnabled").val=true;
            this.GetBoolJSONParam("pelvisIsEnabled").val=true;
            this.GetBoolJSONParam("hipIsEnabled").val=true;
            this.GetBoolJSONParam("rThighIsEnabled").val=true;
            this.GetBoolJSONParam("lThighIsEnabled").val=true;
            this.GetBoolJSONParam("rShinIsEnabled").val=true;
            this.GetBoolJSONParam("lShinIsEnabled").val=true;
            this.GetBoolJSONParam("rFootIsEnabled").val=true;
            this.GetBoolJSONParam("lFootIsEnabled").val=true;
            this.GetBoolJSONParam("LGluteIsEnabled").val=true;
            this.GetBoolJSONParam("RGluteIsEnabled").val=true;
            this.GetBoolJSONParam("abdomenIsEnabled").val=true;
            this.GetBoolJSONParam("abdomen2IsEnabled").val=true;
            this.GetBoolJSONParam("chestIsEnabled").val=true;
            this.GetBoolJSONParam("rCollarIsEnabled").val=true;
            this.GetBoolJSONParam("lCollarIsEnabled").val=true;
            this.GetBoolJSONParam("rShldrIsEnabled").val=true;
            this.GetBoolJSONParam("lShldrIsEnabled").val=true;
            this.GetBoolJSONParam("rForeArmIsEnabled").val=true;
            this.GetBoolJSONParam("lForeArmIsEnabled").val=true;
            this.GetBoolJSONParam("rHandIsEnabled").val=true;
            this.GetBoolJSONParam("lHandIsEnabled").val=true;
            this.GetBoolJSONParam("rPectoralIsEnabled").val=true;
            this.GetBoolJSONParam("lPectoralIsEnabled").val=true;
            this.GetBoolJSONParam("neckIsEnabled").val=true;
            this.GetBoolJSONParam("headIsEnabled").val=true;
        }

        protected void RBpreset_enableMain()
        {
            this.GetBoolJSONParam("rNippleIsEnabled").val=true;
            this.GetBoolJSONParam("lNippleIsEnabled").val=true;
            this.GetBoolJSONParam("pelvisIsEnabled").val=false;
            this.GetBoolJSONParam("hipIsEnabled").val=true;
            this.GetBoolJSONParam("rThighIsEnabled").val=false;
            this.GetBoolJSONParam("lThighIsEnabled").val=false;
            this.GetBoolJSONParam("rShinIsEnabled").val=false;
            this.GetBoolJSONParam("lShinIsEnabled").val=false;
            this.GetBoolJSONParam("rFootIsEnabled").val=false;
            this.GetBoolJSONParam("lFootIsEnabled").val=false;
            this.GetBoolJSONParam("LGluteIsEnabled").val=true;
            this.GetBoolJSONParam("RGluteIsEnabled").val=true;
            this.GetBoolJSONParam("abdomenIsEnabled").val=false;
            this.GetBoolJSONParam("abdomen2IsEnabled").val=false;
            this.GetBoolJSONParam("chestIsEnabled").val=true;
            this.GetBoolJSONParam("rCollarIsEnabled").val=false;
            this.GetBoolJSONParam("lCollarIsEnabled").val=false;
            this.GetBoolJSONParam("rShldrIsEnabled").val=false;
            this.GetBoolJSONParam("lShldrIsEnabled").val=false;
            this.GetBoolJSONParam("rForeArmIsEnabled").val=false;
            this.GetBoolJSONParam("lForeArmIsEnabled").val=false;
            this.GetBoolJSONParam("rHandIsEnabled").val=false;
            this.GetBoolJSONParam("lHandIsEnabled").val=false;
            this.GetBoolJSONParam("rPectoralIsEnabled").val=true;
            this.GetBoolJSONParam("lPectoralIsEnabled").val=true;
            this.GetBoolJSONParam("neckIsEnabled").val=false;
            this.GetBoolJSONParam("headIsEnabled").val=false;
        }

        protected void RBpreset_floatVal()
        {
            this.GetFloatJSONParam("rNippleFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lNippleFloat").val=mobility_light.val;
            this.GetFloatJSONParam("pelvisFloat").val=mobility_strong.val;
            this.GetFloatJSONParam("hipFloat").val=mobility_strong.val;
            this.GetFloatJSONParam("rThighFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lThighFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rShinFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lShinFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rFootFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("lFootFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("LGluteFloat").val=mobility_medium.val;
            this.GetFloatJSONParam("RGluteFloat").val=mobility_medium.val;
            this.GetFloatJSONParam("abdomenFloat").val=mobility_light.val;
            this.GetFloatJSONParam("abdomen2Float").val=mobility_light.val;
            this.GetFloatJSONParam("chestFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("rCollarFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lCollarFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rShldrFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lShldrFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rForeArmFloat").val=mobility_light.val;
            this.GetFloatJSONParam("lForeArmFloat").val=mobility_light.val;
            this.GetFloatJSONParam("rHandFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("lHandFloat").val=mobility_controller.val;
            this.GetFloatJSONParam("rPectoralFloat").val=mobility_medium.val;
            this.GetFloatJSONParam("lPectoralFloat").val=mobility_medium.val;
            this.GetFloatJSONParam("neckFloat").val=mobility_light.val;
            this.GetFloatJSONParam("headFloat").val=mobility_controller.val;
        }

        protected void debug_print_dictionary()
        {
            foreach(KeyValuePair<string,bool> RB_elem in RB_enabled){
                SuperController.LogMessage("updated RB:"+RB_elem.Key+" val:"+RB_enabled[RB_elem.Key]+"");
            }
        }
        
        protected void SyncIsGlobal(bool b)
        {
            isGlobal = b;
        }
		
		protected void SyncIsAvatar(bool b)
        {

            isAvatar = b;
        }

        protected void SyncIsBlowing(bool b)
        {
            isBlowing = b;
        }


        protected void SyncAtomChoices()
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            foreach (string atomUiD in SuperController.singleton.GetAtomUIDs())
                stringList.Add(atomUiD);
            atomJSON.choices = stringList;
        }

        protected void OnAtomRename(string oldid, string newid)
        {
            SyncAtomChoices();
            if (atomJSON == null || !(receivingAtom != null))
                return;
            atomJSON.valNoCallback = receivingAtom.uid;
        }

        protected void SyncAtom(string atomUID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (atomUID != null)
            {
                receivingAtom = SuperController.singleton.GetAtomByUid(atomUID);
                if (receivingAtom != null)
                {
                    foreach (string storableId in receivingAtom.GetStorableIDs())
                    {
                        stringList.Add(storableId);
                    }
                    receiverNameToForceReceiver = new Dictionary<string, ForceReceiver>();
                    foreach (ForceReceiver fr in receivingAtom.forceReceivers)
                    {
                        receiverNameToForceReceiver.Add(fr.name, fr);
                    }
                }
            }
            else
                receivingAtom = (Atom)null;

            receiverJSON.choices = stringList;
            receiverJSON.val = "None";
        }

        protected void CheckMissingReceiver()
        {
            if (!(_missingReceiverStoreId != string.Empty)
                || !(receivingAtom != null)
                || !(receivingAtom.GetStorableByID(_missingReceiverStoreId) != null))
                return;

            string receiverTargetName = _receiverTargetName;
            SyncReceiver(_missingReceiverStoreId);
            _missingReceiverStoreId = string.Empty;
            insideRestore = true;
            receiverTargetJSON.val = receiverTargetName;
            insideRestore = false;
        }

        protected void SyncReceiver(string receiverID)
        {
            List<string> stringList = new List<string>();
            stringList.Add("None");
            if (receivingAtom != null && receiverID != null)
            {
                receiver = receivingAtom.GetStorableByID(receiverID);
                if (receiver != null)
                {
                    foreach (string vector3ParamName in receiver.GetVector3ParamNames())
                    {
                        stringList.Add(vector3ParamName);
                    }
                }
                else if (receiverID != "None")
                    _missingReceiverStoreId = receiverID;
            }
            else
            {
                receiver = null;
            }

            receiverTargetJSON.choices = stringList;
            receiverTargetJSON.val = "None";
        }

        protected void SyncReceiverTarget(string receiverTargetName)
        {
            _receiverTargetName = receiverTargetName;
            receiverTarget = (JSONStorableVector3)null;
            if (receiver != null && receiverTargetName != null)
                receiverTarget = receiver.GetVector3JSONParam(receiverTargetName);
        }

        public UIDynamicTextField CreateTextInput(JSONStorableString jss, bool rightSide = false)
        {
            var textfield = CreateTextField(jss, rightSide);
            textfield.height = 1f;
            //textfield.backgroundColor = Color.white;
            var input = textfield.gameObject.AddComponent<InputField>();
            var rect = input.GetComponent<RectTransform>().sizeDelta = new Vector2(1f, 0.4f);
            input.textComponent = textfield.UItext;
            jss.inputField = input;
            return textfield;
        }

        public void SavePreset(string aPath)
        {
            if (System.String.IsNullOrEmpty(aPath))
            {
                return;
            }
            _lastBrowseDir = aPath.Substring(0, aPath.LastIndexOfAny(new char[] { '/', '\\' })) + @"\";

            if (!aPath.ToLower().EndsWith("WindControl".ToLower()))
            {
                aPath += "." + "WindControl";
            }
            JSONClass saveJson = new JSONClass();
            saveJson["savedBy"] = "WindControl";

            saveJson["rNippleFloat"] = this.GetFloatJSONParam("rNippleFloat").val.ToString();
            saveJson["lNippleFloat"] = this.GetFloatJSONParam("lNippleFloat").val.ToString();
            saveJson["pelvisFloat"] = this.GetFloatJSONParam("pelvisFloat").val.ToString();
            saveJson["hipFloat"] = this.GetFloatJSONParam("hipFloat").val.ToString();
            saveJson["rThighFloat"] = this.GetFloatJSONParam("rThighFloat").val.ToString();
            saveJson["lThighFloat"] = this.GetFloatJSONParam("lThighFloat").val.ToString();
            saveJson["rShinFloat"] = this.GetFloatJSONParam("rShinFloat").val.ToString();
            saveJson["lShinFloat"] = this.GetFloatJSONParam("lShinFloat").val.ToString();
            saveJson["rFootFloat"] = this.GetFloatJSONParam("rFootFloat").val.ToString();
            saveJson["lFootFloat"] = this.GetFloatJSONParam("lFootFloat").val.ToString();
            saveJson["LGluteFloat"] = this.GetFloatJSONParam("LGluteFloat").val.ToString();
            saveJson["RGluteFloat"] = this.GetFloatJSONParam("RGluteFloat").val.ToString();
            saveJson["abdomenFloat"] = this.GetFloatJSONParam("abdomenFloat").val.ToString();
            saveJson["abdomen2Float"] = this.GetFloatJSONParam("abdomen2Float").val.ToString();
            saveJson["chestFloat"] = this.GetFloatJSONParam("chestFloat").val.ToString();
            saveJson["rCollarFloat"] = this.GetFloatJSONParam("rCollarFloat").val.ToString();
            saveJson["lCollarFloat"] = this.GetFloatJSONParam("lCollarFloat").val.ToString();
            saveJson["rShldrFloat"] = this.GetFloatJSONParam("rShldrFloat").val.ToString();
            saveJson["lShldrFloat"] = this.GetFloatJSONParam("lShldrFloat").val.ToString();
            saveJson["rForeArmFloat"] = this.GetFloatJSONParam("rForeArmFloat").val.ToString();
            saveJson["lForeArmFloat"] = this.GetFloatJSONParam("lForeArmFloat").val.ToString();
            saveJson["rHandFloat"] = this.GetFloatJSONParam("rHandFloat").val.ToString();
            saveJson["lHandFloat"] = this.GetFloatJSONParam("lHandFloat").val.ToString();
            saveJson["rPectoralFloat"] = this.GetFloatJSONParam("rPectoralFloat").val.ToString();
            saveJson["lPectoralFloat"] = this.GetFloatJSONParam("lPectoralFloat").val.ToString();
            saveJson["neckFloat"] = this.GetFloatJSONParam("neckFloat").val.ToString();
            saveJson["headFloat"] = this.GetFloatJSONParam("headFloat").val.ToString();

            saveJson["rNippleIsEnabled"] = this.GetBoolJSONParam("rNippleIsEnabled").val.ToString();
            saveJson["lNippleIsEnabled"] = this.GetBoolJSONParam("lNippleIsEnabled").val.ToString();
            saveJson["pelvisIsEnabled"] = this.GetBoolJSONParam("pelvisIsEnabled").val.ToString();
            saveJson["hipIsEnabled"] = this.GetBoolJSONParam("hipIsEnabled").val.ToString();
            saveJson["rThighIsEnabled"] = this.GetBoolJSONParam("rThighIsEnabled").val.ToString();
            saveJson["lThighIsEnabled"] = this.GetBoolJSONParam("lThighIsEnabled").val.ToString();
            saveJson["rShinIsEnabled"] = this.GetBoolJSONParam("rShinIsEnabled").val.ToString();
            saveJson["lShinIsEnabled"] = this.GetBoolJSONParam("lShinIsEnabled").val.ToString();
            saveJson["rFootIsEnabled"] = this.GetBoolJSONParam("rFootIsEnabled").val.ToString();
            saveJson["lFootIsEnabled"] = this.GetBoolJSONParam("lFootIsEnabled").val.ToString();
            saveJson["LGluteIsEnabled"] = this.GetBoolJSONParam("LGluteIsEnabled").val.ToString();
            saveJson["RGluteIsEnabled"] = this.GetBoolJSONParam("RGluteIsEnabled").val.ToString();
            saveJson["abdomenIsEnabled"] = this.GetBoolJSONParam("abdomenIsEnabled").val.ToString();
            saveJson["abdomen2IsEnabled"] = this.GetBoolJSONParam("abdomen2IsEnabled").val.ToString();
            saveJson["chestIsEnabled"] = this.GetBoolJSONParam("chestIsEnabled").val.ToString();
            saveJson["rCollarIsEnabled"] = this.GetBoolJSONParam("rCollarIsEnabled").val.ToString();
            saveJson["lCollarIsEnabled"] = this.GetBoolJSONParam("lCollarIsEnabled").val.ToString();
            saveJson["rShldrIsEnabled"] = this.GetBoolJSONParam("rShldrIsEnabled").val.ToString();
            saveJson["lShldrIsEnabled"] = this.GetBoolJSONParam("lShldrIsEnabled").val.ToString();
            saveJson["rForeArmIsEnabled"] = this.GetBoolJSONParam("rForeArmIsEnabled").val.ToString();
            saveJson["lForeArmIsEnabled"] = this.GetBoolJSONParam("lForeArmIsEnabled").val.ToString();
            saveJson["rHandIsEnabled"] = this.GetBoolJSONParam("rHandIsEnabled").val.ToString();
            saveJson["lHandIsEnabled"] = this.GetBoolJSONParam("lHandIsEnabled").val.ToString();
            saveJson["rPectoralIsEnabled"] = this.GetBoolJSONParam("rPectoralIsEnabled").val.ToString();
            saveJson["lPectoralIsEnabled"] = this.GetBoolJSONParam("lPectoralIsEnabled").val.ToString();
            saveJson["neckIsEnabled"] = this.GetBoolJSONParam("neckIsEnabled").val.ToString();
            saveJson["headIsEnabled"] = this.GetBoolJSONParam("headIsEnabled").val.ToString();

            this.SaveJSON(saveJson, aPath);
        }

        void LoadPreset(string aPath)
        {
            if (System.String.IsNullOrEmpty(aPath))
            {
                return;
            }
            _lastBrowseDir = aPath.Substring(0, aPath.LastIndexOfAny(new char[] { '/', '\\' })) + @"\";
            var aJson = this.LoadJSON(aPath);

            this.GetFloatJSONParam("rNippleFloat").val=aJson["rNippleFloat"].AsFloat;
            this.GetFloatJSONParam("lNippleFloat").val=aJson["lNippleFloat"].AsFloat;
            this.GetFloatJSONParam("pelvisFloat").val=aJson["pelvisFloat"].AsFloat;
            this.GetFloatJSONParam("hipFloat").val=aJson["hipFloat"].AsFloat;
            this.GetFloatJSONParam("rThighFloat").val=aJson["rThighFloat"].AsFloat;
            this.GetFloatJSONParam("lThighFloat").val=aJson["lThighFloat"].AsFloat;
            this.GetFloatJSONParam("rShinFloat").val=aJson["rShinFloat"].AsFloat;
            this.GetFloatJSONParam("lShinFloat").val=aJson["lShinFloat"].AsFloat;
            this.GetFloatJSONParam("rFootFloat").val=aJson["rFootFloat"].AsFloat;
            this.GetFloatJSONParam("lFootFloat").val=aJson["lFootFloat"].AsFloat;
            this.GetFloatJSONParam("LGluteFloat").val=aJson["LGluteFloat"].AsFloat;
            this.GetFloatJSONParam("RGluteFloat").val=aJson["RGluteFloat"].AsFloat;
            this.GetFloatJSONParam("abdomenFloat").val=aJson["abdomenFloat"].AsFloat;
            this.GetFloatJSONParam("abdomen2Float").val=aJson["abdomen2Float"].AsFloat;
            this.GetFloatJSONParam("chestFloat").val=aJson["chestFloat"].AsFloat;
            this.GetFloatJSONParam("rCollarFloat").val=aJson["rCollarFloat"].AsFloat;
            this.GetFloatJSONParam("lCollarFloat").val=aJson["lCollarFloat"].AsFloat;
            this.GetFloatJSONParam("rShldrFloat").val=aJson["rShldrFloat"].AsFloat;
            this.GetFloatJSONParam("lShldrFloat").val=aJson["lShldrFloat"].AsFloat;
            this.GetFloatJSONParam("rForeArmFloat").val=aJson["rForeArmFloat"].AsFloat;
            this.GetFloatJSONParam("lForeArmFloat").val=aJson["lForeArmFloat"].AsFloat;
            this.GetFloatJSONParam("rHandFloat").val=aJson["rHandFloat"].AsFloat;
            this.GetFloatJSONParam("lHandFloat").val=aJson["lHandFloat"].AsFloat;
            this.GetFloatJSONParam("rPectoralFloat").val=aJson["rPectoralFloat"].AsFloat;
            this.GetFloatJSONParam("lPectoralFloat").val=aJson["lPectoralFloat"].AsFloat;
            this.GetFloatJSONParam("neckFloat").val=aJson["neckFloat"].AsFloat;
            this.GetFloatJSONParam("headFloat").val=aJson["headFloat"].AsFloat;

            this.GetBoolJSONParam("rNippleIsEnabled").val=aJson["rNippleIsEnabled"].AsBool;
            this.GetBoolJSONParam("lNippleIsEnabled").val=aJson["lNippleIsEnabled"].AsBool;
            this.GetBoolJSONParam("pelvisIsEnabled").val=aJson["pelvisIsEnabled"].AsBool;
            this.GetBoolJSONParam("hipIsEnabled").val=aJson["hipIsEnabled"].AsBool;
            this.GetBoolJSONParam("rThighIsEnabled").val=aJson["rThighIsEnabled"].AsBool;
            this.GetBoolJSONParam("lThighIsEnabled").val=aJson["lThighIsEnabled"].AsBool;
            this.GetBoolJSONParam("rShinIsEnabled").val=aJson["rShinIsEnabled"].AsBool;
            this.GetBoolJSONParam("lShinIsEnabled").val=aJson["lShinIsEnabled"].AsBool;
            this.GetBoolJSONParam("rFootIsEnabled").val=aJson["rFootIsEnabled"].AsBool;
            this.GetBoolJSONParam("lFootIsEnabled").val=aJson["lFootIsEnabled"].AsBool;
            this.GetBoolJSONParam("LGluteIsEnabled").val=aJson["LGluteIsEnabled"].AsBool;
            this.GetBoolJSONParam("RGluteIsEnabled").val=aJson["RGluteIsEnabled"].AsBool;
            this.GetBoolJSONParam("abdomenIsEnabled").val=aJson["abdomenIsEnabled"].AsBool;
            this.GetBoolJSONParam("abdomen2IsEnabled").val=aJson["abdomen2IsEnabled"].AsBool;
            this.GetBoolJSONParam("chestIsEnabled").val=aJson["chestIsEnabled"].AsBool;
            this.GetBoolJSONParam("rCollarIsEnabled").val=aJson["rCollarIsEnabled"].AsBool;
            this.GetBoolJSONParam("lCollarIsEnabled").val=aJson["lCollarIsEnabled"].AsBool;
            this.GetBoolJSONParam("rShldrIsEnabled").val=aJson["rShldrIsEnabled"].AsBool;
            this.GetBoolJSONParam("lShldrIsEnabled").val=aJson["lShldrIsEnabled"].AsBool;
            this.GetBoolJSONParam("rForeArmIsEnabled").val=aJson["rForeArmIsEnabled"].AsBool;
            this.GetBoolJSONParam("lForeArmIsEnabled").val=aJson["lForeArmIsEnabled"].AsBool;
            this.GetBoolJSONParam("rHandIsEnabled").val=aJson["rHandIsEnabled"].AsBool;
            this.GetBoolJSONParam("lHandIsEnabled").val=aJson["lHandIsEnabled"].AsBool;
            this.GetBoolJSONParam("rPectoralIsEnabled").val=aJson["rPectoralIsEnabled"].AsBool;
            this.GetBoolJSONParam("lPectoralIsEnabled").val=aJson["lPectoralIsEnabled"].AsBool;
            this.GetBoolJSONParam("neckIsEnabled").val=aJson["neckIsEnabled"].AsBool;
            this.GetBoolJSONParam("headIsEnabled").val=aJson["headIsEnabled"].AsBool;


        }

        public override void Init()
        {
            try
            {
                initRBdicts();
                SetDefaultRBmobility();
                SetDefaultRBenabled();

                if ((bool)(SuperController.singleton))
                    SuperController.singleton.onAtomUIDRenameHandlers += new SuperController.OnAtomUIDRename(OnAtomRename);

                isGlobalJSON = new JSONStorableBool("Affect Cloth/Hair", false, new JSONStorableBool.SetBoolCallback(SyncIsGlobal));
				isAvatarJSON = new JSONStorableBool("Affect Avatar", false, new JSONStorableBool.SetBoolCallback(SyncIsAvatar));
                isBlowingJSON = new JSONStorableBool("Suck/Blow", false, new JSONStorableBool.SetBoolCallback(SyncIsBlowing));

                atomJSON = new JSONStorableStringChooser(
                  "atom", SuperController.singleton.GetAtomUIDs(), (string)null,
                  "Atom", new JSONStorableStringChooser.SetStringCallback(SyncAtom));

                atomJSON.popupOpenCallback = new JSONStorableStringChooser.PopupOpenCallback(SyncAtomChoices);
                receiverJSON = new JSONStorableStringChooser(
                  "receiver", (List<string>)null, (string)null,
                  "Receiver", new JSONStorableStringChooser.SetStringCallback(SyncReceiver));


                receiverTargetJSON = new JSONStorableStringChooser(
                  "receiverTarget", (List<string>)null, (string)null,
                  "Target", new JSONStorableStringChooser.SetStringCallback(SyncReceiverTarget));

                currentMagnitudeJSON = new JSONStorableFloat("Current Magnitude (view)", 0.0f, -50f, 50f, false, true);
                autoJSON = new JSONStorableBool("Randomize Current Magnitude", true);
                periodJSON = new JSONStorableFloat("period", 0.03f, 0.0f, 10f, false, true);
                quicknessJSON = new JSONStorableFloat("quickness", 30f, 0.0f, 100f, true, true);
                lowerMagnitudeJSON = new JSONStorableFloat("Lower Magnitude (view)", -50f, -50f, 200f, false, true);
                lowerMagnitudeRatioJSON = new JSONStorableFloat("Lower Magnitude Coeff", -0.25f, -1f, 1f, true, true);
                upperMagnitudeJSON = new JSONStorableFloat("upperMagnitude", 150f, -50f, 150f, false, true);
                targetMagnitudeJSON = new JSONStorableFloat("targetMagnitude", 0.0f, -50f, 50f, false, false);
                windDecay = new JSONStorableFloat("Wind Decay", 0f, 0f, 1f, false, true);
                avatarMobility = new JSONStorableFloat("Avatar Mobility", 10f, 1f, 100f, true, true);
                windStrength = new JSONStorableFloat("Wind Strength", 0f, 0.0f, 300f, false, true);
                windTurbulence = new JSONStorableFloat("Wind dir Turbulence", 0.5f, 0.0f, 1.0f, false, true);

                //RIGIDBODIES
                foreach(KeyValuePair<string,bool> RB_elem in RB_enabled)
                {
                    //Now you can access the key and value both separately from this attachStat as:
                    //SuperController.LogMessage("RB:"+RB_elem.Key+" val:"+RB_elem.Value+"");
                    var tempRB_enab = new JSONStorableBool(RB_elem.Key+"IsEnabled", RB_elem.Value,(bool enabled)=>
                    {
                        RB_enabled[RB_elem.Key]=enabled;
                        //SuperController.LogMessage("updated RB:"+RB_elem.Key+" val:"+RB_enabled[RB_elem.Key]+"");
                    });
                    RegisterBool(tempRB_enab);
                    //SuperController.LogMessage("RB:"+tempRB_enab.val+" val:"+RB_elem.Value+"");
                    CreateToggle(tempRB_enab,true);
                    var temp_mobility=RB_mobility[RB_elem.Key].val;
                    RB_mobility[RB_elem.Key] = new JSONStorableFloat(RB_elem.Key+"Float", temp_mobility, 0.1f, 1.0f, true, true);
                    RegisterFloat(RB_mobility[RB_elem.Key]);   
                    CreateSlider(RB_mobility[RB_elem.Key],true);
                }
                RBpreset_enableMain();

				RegisterBool(isAvatarJSON);
                RegisterBool(isGlobalJSON);
                RegisterBool(isBlowingJSON);
                RegisterStringChooser(atomJSON);
                //RegisterStringChooser(receiverJSON);
                //RegisterStringChooser(receiverTargetJSON);

                RegisterBool(autoJSON);
                RegisterFloat(periodJSON);
                RegisterFloat(quicknessJSON);
                RegisterFloat(upperMagnitudeJSON);
                RegisterFloat(lowerMagnitudeJSON);
                RegisterFloat(lowerMagnitudeRatioJSON);
                RegisterFloat(currentMagnitudeJSON);
                RegisterFloat(windDecay);
                RegisterFloat(windStrength);
                RegisterFloat(windTurbulence);
                RegisterFloat(avatarMobility);

                CreateScrollablePopup(atomJSON, false);
                CreateToggle(isAvatarJSON);
                CreateToggle(isGlobalJSON);
                CreateToggle(isBlowingJSON);
                CreateToggle(autoJSON);
                //CreateScrollablePopup(receiverJSON, true).popupPanelHeight = 1100f;
                //CreateScrollablePopup(receiverTargetJSON, true);
                CreateSlider(windStrength);
                CreateSlider(currentMagnitudeJSON);
                
                //CreateSlider(periodJSON);
                //CreateSlider(quicknessJSON);  
                CreateSlider(lowerMagnitudeRatioJSON);
                CreateSlider(lowerMagnitudeJSON);
                //CreateSlider(upperMagnitudeJSON);
                //CreateSlider(targetMagnitudeJSON);
                CreateSlider(windTurbulence);
                CreateSlider(windDecay);
                CreateSlider(avatarMobility);

                //CreateTextInput(new JSONStorableString("info","COLLIDERS PRESETS"), false);
                var enable_main_btn = CreateButton("Enable Main Colliders", false);
                enable_main_btn.button.onClick.AddListener(RBpreset_enableMain);
                JSONStorableAction enable_main_colliders_action = new JSONStorableAction("Enable Main Colliders", () => {RBpreset_enableMain();});
                RegisterAction(enable_main_colliders_action);

                var disable_all_btn = CreateButton("Disable all Colliders", false);
                disable_all_btn.button.onClick.AddListener(RBpreset_disableAll);
                JSONStorableAction disable_all_colliders_action = new JSONStorableAction("Disable All Colliders", () => {RBpreset_disableAll();});
                RegisterAction(disable_all_colliders_action);

                var enable_all_btn = CreateButton("Enable all Colliders", false);
                enable_all_btn.button.onClick.AddListener(RBpreset_enableAll);
                JSONStorableAction enable_all_colliders_action = new JSONStorableAction("Enable All Colliders", () => {RBpreset_enableAll();});
                RegisterAction(enable_all_colliders_action);

                var reset_all_float_btn = CreateButton("Reset all Colliders Values", false);
                reset_all_float_btn.button.onClick.AddListener(RBpreset_floatVal);
                JSONStorableAction reset_all_colliders_float_action = new JSONStorableAction("Reset All Colliders Values", () => {RBpreset_floatVal();});
                RegisterAction(reset_all_colliders_float_action);

                btn = CreateButton("Save Colliders Preset");
                btn.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.NormalizeMediaPath(_lastBrowseDir);
                    SuperController.singleton.GetMediaPathDialog(SavePreset, "WindControl");

                uFileBrowser.FileBrowser browser = SuperController.singleton.mediaFileBrowserUI;
                    browser.SetTextEntry(true);
                    browser.fileEntryField.text = System.String.Format("{0}.{1}", ((int)(System.DateTime.UtcNow - new System.DateTime(1970, 1, 1)).TotalSeconds).ToString(), "WindControl");
                    browser.ActivateFileNameField();
                });

                btn = CreateButton("Load Colliders Preset");
                btn.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.NormalizeMediaPath(_lastBrowseDir);
                    SuperController.singleton.GetMediaPathDialog(LoadPreset, "WindControl");
                });
            }
            catch (System.Exception e)
            {
                SuperController.LogError("" + e);
            }
        }


        protected void Update()
        {
            if (currentMagnitudeJSON == null)
                return;
            if (autoJSON != null && autoJSON.val)
            {
                timer -= Time.deltaTime;
                if ((double)timer < 0.0)
                {
                    timer = periodJSON.val;
                    //lowerMagnitudeJSON.val=-(windStrength.val/4);
                    lowerMagnitudeJSON.val=windStrength.val*lowerMagnitudeRatioJSON.val;
                    upperMagnitudeJSON.val=windStrength.val;
                    quicknessJSON.val=windStrength.val/5;
                    periodJSON.val=0.2f-(windStrength.val/1000);
                    if(periodJSON.val<0.03f)
                    {
                        periodJSON.val=0.03f;
                    }
                    targetMagnitudeJSON.val = Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
                }
                if(windStrength.val==0)
                {
                    currentMagnitudeJSON.val=0;
                }
                else
                {
                currentMagnitudeJSON.val = Mathf.Lerp(currentMagnitudeJSON.val, targetMagnitudeJSON.val, Time.deltaTime * quicknessJSON.val);
                }
            }
            else
            {
                currentMagnitudeJSON.val=windStrength.val;
                //lowerMagnitudeJSON.val=-(windStrength.val/4);
                lowerMagnitudeJSON.val=windStrength.val*lowerMagnitudeRatioJSON.val;
                upperMagnitudeJSON.val=windStrength.val;
                quicknessJSON.val=windStrength.val/5;
                periodJSON.val=0.2f-(windStrength.val/1000);
                if(periodJSON.val<0.03f)
                {
                    periodJSON.val=0.03f;
                }
            }
            windRandomY=Random.Range(-windTurbulence.val, windTurbulence.val);
            windRandomX=Random.Range(-windTurbulence.val, windTurbulence.val);
            windRandomZ=Random.Range(-windTurbulence.val, windTurbulence.val);
            Vector3 vector3 = currentMagnitudeJSON.val * transform.forward;
            if (isGlobal)
            {
                
				var WindController=containingAtom.GetStorableByID("control").transform;
                Vector3 direction=(new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ)) - receivingAtom.GetStorableByID("chestControl").transform.position;
                if (isBlowing)
                {
                    direction=receivingAtom.GetStorableByID("chestControl").transform.position - (new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ));
                }
                
                
                foreach (string storableId in receivingAtom.GetStorableIDs())
				{
					SyncReceiver(storableId);
                    
                    
					foreach (string vector3ParamName in receiver.GetVector3ParamNames())
					{
						SyncReceiverTarget(vector3ParamName);
						//receiverTarget.val = (currentMagnitudeJSON.val-direction.magnitude) * direction.normalized;
                        var windVariance=Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
                        var distanceFactor=direction.magnitude;
                        var decayFactor=(distanceFactor-(distanceFactor*windDecay.val)+0.001f);
                        if(decayFactor<1)
                        {
                            decayFactor=1;
                        }
                        //SuperController.LogMessage("distanceFactor:"+distanceFactor+"");
                        //receiverTarget.val = (currentMagnitudeJSON.val+Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val))/((0.01f*direction.magnitude*direction.magnitude)-(0.01f*direction.magnitude*direction.magnitude*windDecay.val)+0.001f)*direction.normalized;
                        receiverTarget.val = (currentMagnitudeJSON.val+windVariance)/decayFactor*direction.normalized;
					}
                    
                }
                
            }
            
			if (isAvatar)
			{
                //debug_print_dictionary();
                foreach(KeyValuePair<string,bool> RB_elem in RB_enabled)
                {
                    //Now you can access the key and value both separately from this attachStat as:
                    //SuperController.LogMessage("RB:"+RB_elem.Key+" val:"+RB_elem.Value+"");
                    if(RB_elem.Value)
                    {
                        updateController(RB_elem.Key, RB_mobility[RB_elem.Key].val);
                    }
                }
			}

        }

        protected void getDirection(string controller)
        {
            var WindController=containingAtom.GetStorableByID("control").transform;
            var AvatarController=receivingAtom.GetStorableByID(controller).transform;
            if (isBlowing)
            {
                direction=AvatarController.position - (new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ));
            }
            if (!isBlowing)
            {
                direction=(new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ)) - AvatarController.position;
            }
        }

        protected void updateController(string Controller, float mobility)
        {
            SyncReceiverRB(Controller);
            var WindController=containingAtom.GetStorableByID("control").transform;
            var currentController=receivingAtom.GetStorableByID(Controller).transform;
            var randomValue=Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
            var direction=(new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ)) - currentController.position;
            if (isBlowing)
            {
                direction=currentController.position - (new Vector3(WindController.position.x + windRandomX, WindController.position.y + windRandomY, WindController.position.z + windRandomZ));
            }
            var windVariance=Random.Range(lowerMagnitudeJSON.val, upperMagnitudeJSON.val);
            var distanceFactor=direction.magnitude;
            var decayFactor=(distanceFactor-(distanceFactor*windDecay.val)+avatarMobility.val*mobility);
            if(decayFactor<1)
            {
                decayFactor=1;
            }
            //currentController.position+=(((currentMagnitudeJSON.val+randomValue)/(10000/mobility*avatarMobility.val)) * direction.normalized * windDecay.val/(windDecay.val+direction.magnitude));
            RB.AddForce((currentMagnitudeJSON.val+windVariance)/decayFactor*direction.normalized);
        }

        protected void setControllerStateOff(string controller)
        {
            FreeControllerV3 headControl = receivingAtom.GetStorableByID(controller) as FreeControllerV3;
            headControl.currentPositionState=FreeControllerV3.PositionState.Off;
            headControl.currentRotationState=FreeControllerV3.RotationState.Off;
        }

        protected void setControllerStateComply(string controller)
        {
            FreeControllerV3 headControl = receivingAtom.GetStorableByID(controller) as FreeControllerV3;
            headControl.currentPositionState=FreeControllerV3.PositionState.Comply;
            headControl.currentRotationState=FreeControllerV3.RotationState.Comply;
        }

        protected void setWindTurbulence()
        {
            var windRandomY=Random.Range(0, windTurbulence.val);
            var windRandomX=Random.Range(-windTurbulence.val, windTurbulence.val);
            var windRandomZ=Random.Range(-windTurbulence.val, windTurbulence.val);
            newDirection = new Vector3(containingAtom.GetStorableByID("control").transform.forward.x + windRandomX, containingAtom.GetStorableByID("control").transform.forward.y , containingAtom.GetStorableByID("control").transform.forward.z + windRandomZ).normalized;
        }

        protected void OnDestroy()
        {
            if (SuperController.singleton)
                SuperController.singleton.onAtomUIDRenameHandlers -= new SuperController.OnAtomUIDRename(OnAtomRename);
        }
    }

}
